'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbspritedemo.exe"
#Dim All
%Unicode = 1

#Include "Win32API.inc"
#Include "cgdiplus.inc"

#Resource Icon logo, "icons\gbspritedemo.ico"
#Resource Icon xclear, "icons\new.ico"
#Resource Icon xreset, "icons\reset.ico"
#Resource Icon xsettings, "icons\settings.ico"
#Resource Icon xhelp, "icons\help.ico"
#Resource Icon xopen, "icons\open.ico"
#Resource Icon xcentered, "icons\centered.ico"
#Resource Icon xautoclear, "icons\autoclear.ico"
#Resource Icon xonlyone, "icons\onlyone.ico"
#Resource Icon xoutlines, "icons\outlines.ico"
#Resource Icon xzoom, "icons\zoom.ico"

$SessionBMP = "sprites\session.bmp"
$ver = "1.01"

Type CustomColors
   c(15) As Long
End Type

Enum Equates Singular
   IDT_Open = 500
   IDT_Clear
   IDT_OnlyOne
   IDT_ResetTheta
   IDT_ResetSprite
   IDT_Graphic
   IDT_TColor
   IDT_BGColor
   IDT_Centered
   IDT_AutoClear
   IDT_Outlines
   IDT_Zoom
   IDT_Settings
   IDT_Help

   IDC_Graphic
   IDC_Name
   IDC_Toolbar
   IDC_Theta

   IDM_LocalHelp
End Enum

Global hDlg,hGraphic,hFont,hToolbar,hImageList As Dword, FileName As WStringZ * %Max_Path
Global TColor, BGColor, Zoom, AutoClear, Centered, ShowOutlines As Long, Theta As Single, ptTarget As Point
Global CustomColorList As CustomColors, OldGraphicProc As Long, SpriteR, SpriteN As Rect

Function PBMain() As Long
   Dialog New Pixels, 0, "gbSpriteDemo    v" + $ver,300,300,400,400, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   Control Add Label, hDlg, %IDC_Theta,"Angle: 0", 10,60,65,20, %WS_Border Or %SS_CenterImage Or %SS_Center
   Control Add TextBox, hDlg, %IDC_Name, "", 80,60,400,20
   Control Add Graphic, hDlg, %IDC_Graphic, "", 0,90,400,400, %SS_Notify
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local w,h As Long, temp$, PTT As TooltipText Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
         BuildAcceleratorTable
         If IsFolder (Exe.Path$ + "sprites") = %False Then MkDir Exe.Path$ + "sprites"
         Font New "Tahoma",8,0 To hFont
         Control Set Font hDlg, %IDC_Theta, hFont
         Control Set Font hDlg, %IDC_Name, hFont
         settings_ini "get"
         CreateImageList
         CreateToolbar
         Control Set Text hDlg, %IDC_Theta, "Angle:  " + Str$(Theta)
         Theta = Theta * 0.01745
         Control Set Text hDlg, %IDC_Name, FileName
         Control Handle hDlg, %IDC_Graphic To hGraphic
         OldGraphicProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Graphic), %GWL_WndProc, CodePtr(NewGraphicProc))
         Graphic Attach hDlg, %IDC_Graphic, ReDraw
         Graphic Color %Black, BGColor
         Graphic Clear
         Graphic Set Font hFont
         ShowHelp
         If IsFalse(IsFile(Exe.Path$ + Exe.Name$ + ".ini")) And IsFile($SessionBMP) Then Kill $SessionBMP
         ResizeWindow
         If IsFile($SessionBMP) Then
            Dialog Get Client hDlg To w,h
            Graphic Render Bitmap $SessionBMP, (0,0) - (w-1,h-1)
         Else
            DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget,Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
         End If
         SetMenusAndToolbar
         Control Set Focus hDlg, %IDC_Name
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_Open         : SelectImage
            Case %IDT_Clear        : Graphic Clear : Graphic ReDraw : Reset SpriteR
            Case %IDT_OnlyOne
               Graphic Clear
               DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget, Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
               Control Set Focus hDlg, %IDC_Name
            Case %IDT_Centered     : Centered Xor= 1
            Case %IDT_Outlines
               If MsgBox("Are you sure? This will erase all but the most recent sprite!", %MB_OkCancel + %MB_IconQuestion, "Set Background Color") = %IdCancel Then Exit Function
               Graphic Clear
               ShowOutlines Xor= 1
               DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget, Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
               Control Set Focus hDlg, %IDC_Name
            Case %IDT_AutoClear
               AutoClear Xor= 1
               If AutoClear Then
                  Graphic Clear
                  DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget, Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
                  Control Set Focus hDlg, %IDC_Name
               End If
            Case %IDT_ResetSprite
               Theta = 0 : Control Set Text hDlg, %IDC_Theta, "Angle:  0"
               If AutoClear Then Graphic Clear
               DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget, Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
               Control Set Focus hDlg, %IDC_Name
            Case %IDT_ResetTheta
               Theta = 0 : Control Set Text hDlg, %IDC_Theta, "Angle:  0"
            Case %IDT_TColor
               TColor = SelectColor(TColor)
               CreateImageList
               Control Kill hDlg, %IDC_Toolbar
               CreateToolbar
               SetMenusAndToolbar
            Case %IDT_BGColor
               If MsgBox("Are you sure? This will erase all but the most recent sprite!", %MB_OkCancel + %MB_IconQuestion, "Set Background Color") = %IdCancel Then Exit Function
               BGColor = SelectColor(BGColor)
               Graphic Color %Black, BGColor
               Graphic Clear
               DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget, Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
               Control Set Focus hDlg, %IDC_Name
               Graphic ReDraw
               CreateImageList
               Control Kill hDlg, %IDC_Toolbar
               CreateToolbar
               SetMenusAndToolbar
            Case %IDT_Zoom
               Select Case Zoom
                  Case 25   : Zoom = 50
                  Case 50   : Zoom = 100
                  Case 100  : Zoom = 200
                  Case 200  : Zoom = 400
                  Case 400  : Zoom = 25
               End Select
               Control Kill hDlg, %IDC_Toolbar
               CreateToolbar
               SetMenusAndToolbar

            Case %IDT_Help
               w = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbspritedemo.htm", $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_LocalHelp
               ShowHelp
               Graphic ReDraw
         End Select
      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_Open To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_Open        : @PTT.@lpszText = "Select new sprite image"
                        Case %IDT_Clear       : @PTT.@lpszText = "Remove all sprites"
                        Case %IDT_OnlyOne     : @PTT.@lpszText = "Remove all but the last sprite"
                        Case %IDT_ResetSprite : @PTT.@lpszText = "Set last sprite rotation to zero"
                        Case %IDT_ResetTheta  : @PTT.@lpszText = "Set rotation angle to zero (for next sprite)"
                        Case %IDT_Zoom        : @PTT.@lpszText = "Cycles through zoom settings (25%-400%)"
                        Case %IDT_TColor      : @PTT.@lpszText = "Set sprite transparent color""
                        Case %IDT_BGColor     : @PTT.@lpszText = "Set display background color"
                        Case %IDT_AutoClear   : @PTT.@lpszText = "Clear screen before each sprite"
                        Case %IDT_Outlines    : @PTT.@lpszText = "Show image outline/center"
                        Case %IDT_Centered    : @PTT.@lpszText = "Center sprite at cursor"
                        Case %IDT_Help        : @PTT.@lpszText = "Online Help (Ctrl-H for local Help)"
                     End Select
               End Select
         End Select
      Case %WM_MouseWheel
         Control Get Text hDlg, %IDC_Theta To temp$
         Replace "Angle:" With "" In temp$
         w = Val(temp$)
         Select Case Hi(Integer,Cb.WParam)    'note the use of Integer
            Case > 0 : w += 5
            Case < 0 : w -= 5
         End Select
         Control Set Text hDlg, %IDC_Theta, "Angle:  " + Str$(w)
         Theta = w * 0.01745
         Control Get Text hDlg, %IDC_Name To FileName
         If AutoClear Then Graphic Clear
         DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget, Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
         Graphic ReDraw
      Case %WM_Size
         ResizeWindow
      Case %WM_Destroy
         Control Get Text hDlg, %IDC_Theta To temp$
         Replace "Angle:" With "" In temp$
         Theta = Val(temp$)
         Graphic Save $SessionBMP
         SetWindowLong GetDlgItem(hDlg, %IDC_Graphic), %GWL_WNDPROC, OldGraphicProc   'un-subclass
         settings_ini "save"
   End Select
End Function

Sub ResizeWIndow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Client hDlg, %IDC_Graphic, w,h
   Control Set Size hDlg, %IDC_Name, w-90,20
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "200", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "200", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "630", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileName", Exe.Path$ + "sprites\world.png", FileName, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "SpriteLeft", "0", temp, %Max_Path, INIFileName:  SpriteR.nLeft = Val(temp)
      Getprivateprofilestring "All", "SpriteTop", "0", temp, %Max_Path, INIFileName:  SpriteR.nTop = Val(temp)
      Getprivateprofilestring "All", "SpriteRight", "0", temp, %Max_Path, INIFileName:  SpriteR.nRight = Val(temp)
      Getprivateprofilestring "All", "SpriteBottom", "0", temp, %Max_Path, INIFileName:  SpriteR.nBottom = Val(temp)
      Getprivateprofilestring "All", "Theta", "0", temp, %Max_Path, INIFileName:  Theta = Val(temp)
      Getprivateprofilestring "All", "XTarget", "200", temp, %Max_Path, INIFileName:  ptTarget.x = Val(temp)
      Getprivateprofilestring "All", "YTarget", "125", temp, %Max_Path, INIFileName:  ptTarget.y = Val(temp)
      Getprivateprofilestring "All", "Centered", "1", temp, %Max_Path, INIFileName:  Centered = Val(temp)
      Getprivateprofilestring "All", "AutoClear", "1", temp, %Max_Path, INIFileName:  AutoClear = Val(temp)
      Getprivateprofilestring "All", "TColor", Str$(%Black), temp, %Max_Path, INIFileName:  TColor = Val(temp)
      Getprivateprofilestring "All", "BGColor", Str$(%rgb_LightBlue), temp, %Max_Path, INIFileName:  BGColor = Val(temp)
      Getprivateprofilestring "All", "ShowOutlines", "0", temp, %Max_Path, INIFileName:  ShowOutlines = Val(temp)
      Getprivateprofilestring "All", "Zoom", "100", temp, %Max_Path, INIFileName:  Zoom = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "SpriteLeft", Str$(SpriteR.nLeft), INIFileName
      WritePrivateProfileString "All", "SpriteTop", Str$(SpriteR.nTop), INIFileName
      WritePrivateProfileString "All", "SpriteRight", Str$(SpriteR.nRight), INIFileName
      WritePrivateProfileString "All", "SpriteBottom", Str$(SpriteR.nBottom), INIFileName
      WritePrivateProfileString "All", "Theta", Str$(Theta), INIFileName
      WritePrivateProfileString "All", "XTarget", Str$(ptTarget.x), INIFileName
      WritePrivateProfileString "All", "YTarget", Str$(ptTarget.y), INIFileName
      WritePrivateProfileString "All", "Centered", Str$(Centered), INIFileName
      WritePrivateProfileString "All", "AutoClear", Str$(AutoClear), INIFileName
      WritePrivateProfileString "All", "TColor", Str$(TColor), INIFileName
      WritePrivateProfileString "All", "BGColor", Str$(BGColor), INIFileName
      WritePrivateProfileString "All", "ShowOutlines", Str$(ShowOutlines), INIFileName
      WritePrivateProfileString "All", "Zoom", Str$(Zoom), INIFileName
   End If
End Sub

Function SelectImage As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "Image Files" + $Nul + "*.bmp;*.jpg;*.gif;*.png" + $Nul
    startfolder$ = IIf$(IsFile(FileName), PathName$(Path, FileName), Exe.Path$ + "images")     'initial folder to be displayed
    startfile$ = FileName       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then FileName = filevar$ : Control Set Text hDlg, %IDC_Name, FileName
End Function

Sub CreateImageList
   ImageList Kill hImageList
   ImageList New Icon 24,24,24,10 To hImageList
   ImageList Add Icon hImageList, "xopen"       '1
   ImageList Add Icon hImageList, "xclear"      '2
   ImageList Add Icon hImageList, "xreset"      '3
   ImageList Add Icon hImageList, "xcentered"   '4
   ImageList Add Icon hImageList, "xautoclear"  '5
   ImageList Add Icon hImageList, "xhelp"       '6
   ImageList Add Icon hImageList, "logo"        '7
   ImageList Add Icon hImageList, "xonlyone"    '8
   ImageList Add Icon hImageList, "xoutlines"   '9
   ImageList Add Icon hImageList, "xzoom"       '10
   ImageList Add Icon hImageList, CreateColorIcon(TColor)
   ImageList Add Icon hImageList, CreateColorIcon(BGColor)
End Sub

Sub CreateToolbar
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0
    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_Open, %BTNS_Button, "Select"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Clear, %BTNS_Button, "Clear"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_OnlyOne, %BTNS_Button, "Last Only"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_ResetSprite, %BTNS_Button, "Sprite"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_ResetTheta, %BTNS_Button, "Theta"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_Zoom, %BTNS_Button, IIf$(Zoom > 75, LTrim$(Str$(Zoom))+"%",Str$(Zoom)+ " %")
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11,  %IDT_TColor, %BTNS_Button, "T-Color"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12,  %IDT_BGColor, %BTNS_Button, "BG-Color"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Outlines, %BTNS_Check, "Outlines"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Centered, %BTNS_Check, "Centered"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_AutoClear, %BTNS_Check, "AutoClear"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Help,  %BTNS_Button, "Help"
    Control Set Font hDlg, %IDC_Toolbar, hFont
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Centered,  Centered * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AutoClear,  AutoClear * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Outlines,  ShowOutlines * %TBState_Checked Or %TBState_Enabled
   'Menus
'    Menu Set State hSettings, ByCmd %IDM_OnTop, OnTop * %MFS_Checked Or %MFS_Enabled
End Sub

Sub BuildAcceleratorTable
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(9)
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F1    : ac(cc).cmd  = %IDT_Help         : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_A     : ac(cc).cmd  = %IDT_AutoClear    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_B     : ac(cc).cmd  = %IDT_BGColor      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_H     : ac(cc).cmd  = %IDM_LocalHelp    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_N     : ac(cc).cmd  = %IDT_Clear        : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_O     : ac(cc).cmd  = %IDT_Open         : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_T     : ac(cc).cmd  = %IDT_TColor       : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_Z     : ac(cc).cmd  = %IDT_ResetTheta   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_S     : ac(cc).cmd  = %IDT_Outlines : Incr cc
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub ShowHelp
   Graphic Set Pos (10,10) : Graphic Print "Click location to display sprite ..."
   Graphic Set Pos (10,30) : Graphic Print "Rotate MouseWheel to spin latest sprite/set angle for next sprite ..."
   Graphic Set Pos (10,50) : Graphic Print "Ctrl-Drag the most recent icon to a new location ..."
   Graphic Set Pos (10,70) : Graphic Print "Ctrl-H for Local Help ..."
End Sub

Function CreateColorIcon(iColor As Long) As Dword
   Local B As Bitmap, iPos As Long, x,y,w,h As Long, hBMPXOR, hBMPAND As Dword, bmp$, P As IconInfo

   'Create an XOR bitmap using the bitstring in bmp$
   w = 16 : h = 16
   Graphic Bitmap New w,h To hBMPXOR
   Graphic Attach hBMPXOR, 0
   Graphic Clear iColor
   Graphic Get Bits To bmp$

   'create the bit array for the monochrome MASK bitmask. &HECE9D8 is transparent color
   Dim Mask(1 To w*h/8) As Byte
   For x = 9 To Len(bmp$) Step 4
      Bit Reset Mask(1),(iPos And &hfffffff8) + 7 - (iPos And &h7) 'bit is not transparent
      Incr iPos
   Next

   'fill out the MASK bitmap variable information
   B.bmType = 0           :   B.bmWidth = w    :   B.bmHeight = h
   B.bmWidthBytes = w/8   :   B.bmPlanes = 1   :   B.bmBitsPixel = 1
   B.bmBits = VarPtr(Mask(1))

   'create the MASK bitmap
   hBMPAND = CreateBitmapIndirect(B)

   'fill in the ICONINFO variable and create the icon (.xHotSpot/.yHotSpot are ignored)
   P.fIcon = %True
   P.hbmColor = hBMPXOR
   P.hbmMask = hBMPAND
   Function = CreateIconIndirect (P)

   'reattach to target Graphic target
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
End Function

Sub DrawSprite(hTargetParent As Dword, TargetID As Long, ImgName As String, Angle As Single, NewPT As Point, _
              CenterImage As Long, TColor As Long, Outlines As Long, Zoom As Long, imgRectR As Rect, imgRectN As Rect)
   Local pGraphics,pImage,token, hTargetDC As Dword, StartupInput As GdiplusStartupInput
   Local imgW,imgH, imgWR, imgHR,XCenter,YCenter, cx,cy As Long, hBMP,hDC,hBMPR,hDCR As Dword, i,x,y As Long
   Dim PlgPts(0 To 2) As PointAPI

   If IsFalse(IsFile(ImgName)) Then Beep : Exit Sub

   'initialize GDI
   StartupInput.GdiplusVersion = 1                    'initialize GDIPlus
   GdiplusStartup(token, StartupInput, ByVal %NULL)   'initialize GDIPlus

   GdipLoadImageFromFile((ImgName), pImage)           'load image
   GdipGetImageWidth(pImage,imgW)                     'get width
   GdipGetImageHeight(pImage,imgH)                    'get height
   imgW = (Zoom/100) * imgW
   imgH = (Zoom/100) * imgH
   If Centered = 0 Then cx = IIf(imgW Mod 2 = 0, 0,1)                      'odd/even image detection
   If Centered = 0 Then cy = IIf(imgH Mod 2 = 0, 0,1)                      'odd/even image detection

   Graphic Bitmap New imgW, imgH To hBMP
   Graphic Attach hBMP, 0
   Graphic Get DC To hDC

   GdipCreateFromHDC(hDC, pGraphics)                   ' Create the Graphic object
   GdipDrawImageRect(pGraphics, pImage, 0, 0, imgW, imgH)  ' Draw the image

   'shutdown GDI
   If pImage Then GdipDisposeImage(pImage)            'cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)    'cleanup
   GdiplusShutdown token                              'shutdown GDI+

   'rotation bitmap
   imgWR = Sqr(imgW*imgW + imgH*imgH)+6 : imgHR = imgWR  '6 is arbitrary - just to make sure there's room
   Graphic Bitmap New imgWR,imgHR To hBMPR
   Graphic Attach hBMPR, 0
   Graphic Color TColor, TColor
   Graphic Get DC To hDCR

   'rotation of original bitmap to a temporary memory bitmap
   XCenter = imgW\2
   YCenter = imgH\2

   x = 0 : y = 0   'point in original bitmap
   PlgPts(0).X = imgWR\2 + (x - XCenter) * Cos(angle) - (y - YCenter) * Sin(angle)  'upper-left in target
   PlgPts(0).Y = imgHR\2 + (x - XCenter) * Sin(angle) + (y - YCenter) * Cos(angle)
   x = imgW : y = 0   'point in original bitmap
   PlgPts(1).X = imgWR\2 + (x - XCenter) * Cos(angle) - (y - YCenter) * Sin(angle)  'upper-right in target
   PlgPts(1).Y = imgHR\2 + (x - XCenter) * Sin(angle) + (y - YCenter) * Cos(angle)
   x = 0 : y = imgH   'point in original bitmap
   PlgPts(2).X = imgWR\2 + (x - XCenter) * Cos(angle) - (y - YCenter) * Sin(angle)  'lower left in target
   PlgPts(2).Y = imgHR\2 + (x - XCenter) * Sin(angle) + (y - YCenter) * Cos(angle)
   Graphic Attach hBMPR, 0
   Graphic Clear

   PlgBlt(hDCR, PlgPts(0), hDC, 0, 0, imgW, imgH, 0&, 0, 0)  ' Draw rotated image
   'place rotated bitmap into the main graphic
   Graphic Attach hTargetParent, TargetID, ReDraw
   Graphic Set Overlap %True
   Graphic Get DC To hTargetDC
   If CenterImage Then
      imgRectR.nLeft = NewPT.x-imgWR\2 : imgRectR.nTop  = NewPT.y-imgHR\2
      imgRectN.nLeft = NewPT.x-imgW\2  : imgRectN.nTop  = NewPT.y-imgH\2
      TransparentBlt hTargetDC,imgRectR.nLeft,imgRectR.nTop,imgWR,imgHR,hDCR,0,0,imgWR,imgHR,TColor
   Else
      imgRectR.nLeft = NewPT.x-(imgWR-imgW)\2 : imgRectR.nTop  = NewPT.y-(imgHR-imgH)\2
      imgRectN.nLeft = NewPT.x                : imgRectN.nTop  = NewPT.y
      TransparentBlt hTargetDC,imgRectR.nLeft,imgRectR.nTop,imgWR,imgHR,hDCR,0,0,imgWR,imgHR,TColor
   End If
   imgRectR.nRight  = imgRectR.nLeft + imgWR -1 : imgRectR.nBottom = imgRectR.nTop + imgHR - 1
   imgRectN.nRight  = imgRectN.nLeft + imgW  -1 : imgRectN.nBottom = imgRectN.nTop + imgH - 1

   If Outlines Then
      Graphic Box (imgRectR.nLeft-1+cx,imgRectR.nTop-1+cy)-(imgRectR.nRight+1+cx,imgRectR.nBottom+1+cx),,%Red   'rotation border
      Graphic Box (imgRectN.nLeft-1+cx,imgRectN.nTop-1+cy)-(imgRectN.nRight+1+cy,imgRectN.nBottom+1+cy),,%Red   'non-rotated border
      'center of image
      x = imgRectN.nLeft + (imgRectN.nRight - imgRectN.nLeft)\2 + cx
      y = imgRectN.nTop  + (imgRectN.nBottom - imgRectN.nTop)\2 + cy
      Graphic Box (x-3,y-3)-(x+3,y+3),,%Blue
   End If

   'delete created memory bitmaps
   Graphic Attach hBMP, 0
   Graphic Bitmap End
   Graphic Attach hBMPR, 0
   Graphic Bitmap End

   'reattach to target Graphic target
   Graphic Attach hTargetParent, TargetID, ReDraw
   Graphic ReDraw
End Sub

Function NewGraphicProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Static ddx, ddy As Long
   Select Case Msg
      Case %WM_LButtonDown
         ptTarget.x = Lo(Word,LParam) : ptTarget.y = Hi(Word, LParam)
         If (WParam And %MK_CONTROL) And PtInRect(SpriteR,ptTarget) Then 'get ready to move sprite
            SetCapture hGraphic
            If Centered Then
               ddx = SpriteR.nLeft + (SpriteR.nRight - SpriteR.nLeft) /2  - ptTarget.x
               ddy = SpriteR.nTop   + (SpriteR.nBottom - SpriteR.nTop) / 2 - ptTarget.y
            Else
               ddx = SpriteN.nLeft - ptTarget.x
               ddy = SpriteN.nTop - ptTarget.y
            End If
         Else  'new sprite
            ddx = 0 : ddy = 0
            If AutoClear Then Graphic Clear
            Control Get Text hDlg, %IDC_Name To FileName
            DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget, Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
         End If
      Case %WM_MouseMove
         If GetCapture = hGraphic Then
            Control Get Text hDlg, %IDC_Name To FileName
            If AutoClear Then Graphic Clear
            ptTarget.x = Lo(Word,LParam) + ddx
            ptTarget.y = Hi(Word, LParam) + ddy
            DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget, Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
         End If
      Case %WM_LButtonUp
         ReleaseCapture
         Control Set Focus hDlg, %IDC_Name
   End Select
   Function = CallWindowProc(OldGraphicProc, hWnd, Msg, wParam, lParam)
End Function
