'Compilable Example:
#Compiler PBWin 10
#Compile Exe  "gbspritedemo_simple.exe"
#Dim All
%Unicode = 1
#Include "Win32API.inc"
#Include "cgdiplus.inc"

%IDC_Graphic = 500
%ID_Timer = 501

Global hDlg,hGraphic As Dword, FileName As WStringZ * %Max_Path, ptTarget As Point
Global SpriteR, SpriteN As Rect, theta As Single, XCenter, YCenter As Long
Global TColor, ShowOutlines, Zoom, AutoClear, Centered As Long
Global qFreq, qStart, qStop As Quad
Function PBMain() As Long
   Dialog New Pixels, 0, "Sprite Demo",300,300,200,200, %WS_OverlappedWindow To hDlg
   Control Add Graphic, hDlg, %IDC_Graphic, "", 0,0,200,200, %SS_Notify
   Control Handle hDlg, %IDC_Graphic To hGraphic
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local w,h,x,y,i As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         QueryPerformanceFrequency qFreq
         Centered = 1 : AutoClear = 1 : Theta = 0
         TColor = %Black : ShowOutlines = 0 : Zoom = 100
         FileName = "sprites\world.png"
         SetTimer hDlg, %ID_Timer, 100, 0
      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Client hDlg, %IDC_Graphic, w,h
         XCenter = w/2 : YCenter = h/2
      Case %WM_Timer
         QueryPerformanceCounter   qStart
         For i = 1 To 25
            Theta += 0.05
            ptTarget.X = XCenter + 50 * Sin(theta)
            ptTarget.Y = YCenter + 50 * Cos(theta)
            If AutoClear Then Graphic Clear
            DrawSprite hDlg, %IDC_Graphic, (FileName), theta, ptTarget, Centered, TColor, ShowOutlines, Zoom, SpriteR, SpriteN
         Next i
         QueryPerformanceCounter   qStop
         Dialog Set Text hDlg, Format$((qStop-qStart)/qFreq,"###.000") & " seconds"
   End Select
End Function

Sub DrawSprite(hTargetParent As Dword, TargetID As Long, ImgName As String, Angle As Single, NewPT As Point, _
              CenterImage As Long, TColor As Long, Outlines As Long, Zoom As Long, imgRectR As Rect, imgRectN As Rect)
   Local pGraphics,pImage,token, hTargetDC As Dword, StartupInput As GdiplusStartupInput
   Local imgW,imgH, imgWR, imgHR,XCenter,YCenter, cx,cy As Long, hBMP,hDC,hBMPR,hDCR As Dword, i,x,y As Long
   Dim PlgPts(0 To 2) As PointAPI

   If IsFalse(IsFile(ImgName)) Then Beep : Exit Sub

   'initialize GDI
   StartupInput.GdiplusVersion = 1                    'initialize GDIPlus
   GdiplusStartup(token, StartupInput, ByVal %NULL)   'initialize GDIPlus

   GdipLoadImageFromFile((ImgName), pImage)           'load image
   GdipGetImageWidth(pImage,imgW)                     'get width
   GdipGetImageHeight(pImage,imgH)                    'get height
   imgW = (Zoom/100) * imgW
   imgH = (Zoom/100) * imgH
   If CenterImage = 0 Then cx = IIf(imgW Mod 2 = 0, 0,1)                      'odd/even image detection
   If CenterImage = 0 Then cy = IIf(imgH Mod 2 = 0, 0,1)                      'odd/even image detection

   Graphic Bitmap New imgW, imgH To hBMP
   Graphic Attach hBMP, 0
   Graphic Get DC To hDC

   GdipCreateFromHDC(hDC, pGraphics)                   ' Create the Graphic object
   GdipDrawImageRect(pGraphics, pImage, 0, 0, imgW, imgH)  ' Draw the image

   'shutdown GDI
   If pImage Then GdipDisposeImage(pImage)            'cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)    'cleanup
   GdiplusShutdown token                              'shutdown GDI+

   'rotation bitmap
   imgWR = Sqr(imgW*imgW + imgH*imgH)+6 : imgHR = imgWR  '6 is arbitrary - just to make sure there's room
   Graphic Bitmap New imgWR,imgHR To hBMPR
   Graphic Attach hBMPR, 0
   Graphic Color TColor, TColor
   Graphic Get DC To hDCR

   'rotation of original bitmap to a temporary memory bitmap
   XCenter = imgW\2
   YCenter = imgH\2

   x = 0 : y = 0   'point in original bitmap
   PlgPts(0).X = imgWR\2 + (x - XCenter) * Cos(angle) - (y - YCenter) * Sin(angle)  'upper-left in target
   PlgPts(0).Y = imgHR\2 + (x - XCenter) * Sin(angle) + (y - YCenter) * Cos(angle)
   x = imgW : y = 0   'point in original bitmap
   PlgPts(1).X = imgWR\2 + (x - XCenter) * Cos(angle) - (y - YCenter) * Sin(angle)  'upper-right in target
   PlgPts(1).Y = imgHR\2 + (x - XCenter) * Sin(angle) + (y - YCenter) * Cos(angle)
   x = 0 : y = imgH   'point in original bitmap
   PlgPts(2).X = imgWR\2 + (x - XCenter) * Cos(angle) - (y - YCenter) * Sin(angle)  'lower left in target
   PlgPts(2).Y = imgHR\2 + (x - XCenter) * Sin(angle) + (y - YCenter) * Cos(angle)
   Graphic Attach hBMPR, 0
   Graphic Clear

   PlgBlt(hDCR, PlgPts(0), hDC, 0, 0, imgW, imgH, 0&, 0, 0)  ' Draw rotated image
   'place rotated bitmap into the main graphic
   Graphic Attach hTargetParent, TargetID, ReDraw
   Graphic Set Overlap %True
   Graphic Get DC To hTargetDC
   If CenterImage Then
      imgRectR.nLeft = NewPT.x-imgWR\2 : imgRectR.nTop  = NewPT.y-imgHR\2
      imgRectN.nLeft = NewPT.x-imgW\2  : imgRectN.nTop  = NewPT.y-imgH\2
      TransparentBlt hTargetDC,imgRectR.nLeft,imgRectR.nTop,imgWR,imgHR,hDCR,0,0,imgWR,imgHR,TColor
   Else
      imgRectR.nLeft = NewPT.x-(imgWR-imgW)\2 : imgRectR.nTop  = NewPT.y-(imgHR-imgH)\2
      imgRectN.nLeft = NewPT.x                : imgRectN.nTop  = NewPT.y
      TransparentBlt hTargetDC,imgRectR.nLeft,imgRectR.nTop,imgWR,imgHR,hDCR,0,0,imgWR,imgHR,TColor
   End If
   imgRectR.nRight  = imgRectR.nLeft + imgWR -1 : imgRectR.nBottom = imgRectR.nTop + imgHR - 1
   imgRectN.nRight  = imgRectN.nLeft + imgW  -1 : imgRectN.nBottom = imgRectN.nTop + imgH - 1

   If Outlines Then
      Graphic Box (imgRectR.nLeft-1+cx,imgRectR.nTop-1+cy)-(imgRectR.nRight+1+cx,imgRectR.nBottom+1+cx),,%Red   'rotation border
      Graphic Box (imgRectN.nLeft-1+cx,imgRectN.nTop-1+cy)-(imgRectN.nRight+1+cy,imgRectN.nBottom+1+cy),,%Red   'non-rotated border
      'center of image
      x = imgRectN.nLeft + (imgRectN.nRight - imgRectN.nLeft)\2 + cx
      y = imgRectN.nTop  + (imgRectN.nBottom - imgRectN.nTop)\2 + cy
      Graphic Box (x-3,y-3)-(x+3,y+3),,%Blue
   End If

   'delete created memory bitmaps
   Graphic Attach hBMP, 0
   Graphic Bitmap End
   Graphic Attach hBMPR, 0
   Graphic Bitmap End

   'reattach to target Graphic target
   Graphic Attach hTargetParent, TargetID, ReDraw
   Graphic ReDraw
End Sub
